/*************************************************************************
    fsadm - File system administrator
    1.00 85-09-16 Henrik Norbeck, Luxor Datorer AB
   
    file.c inneh}ller filhanteringsfunktioner
*************************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "fsadm.h"
#include "struct.h"

extern struct viewport port[];

extern char cwd[];

/*** Om filen ligger i nuvarande arbetsbibliotek returneras endast
	filnamnet, annars returneras fullst{ndiga s|kv{gen ***/
char *getpath(filep)
register struct file_info *filep;
{
    return ((strncmp(cwd, filep->path, filep->name - filep->path))
				 ? filep->path : filep->name);
}

/*** K|r ett annat program ***/
exec(path, arg)
char *path, *arg;
{
    int status;
    register int f_id, fd;

    if ((f_id = fork()) == 0) {	/* Dotterprocess */
	if ((fd = open("/dev/null", O_RDWR)) != ERROR) {
	    dup2(fd, STDIN);
	    dup2(fd, STDOUT);
	    dup2(fd, STDERR);
	    close(fd);
	    }
	execl(path, path, arg, NULL);
	exit(1);
	}
    else if (f_id == ERROR) {
	message(CANT_FORK, NULL);
	return(ERROR);
	}
    else {
	while (wait(&status) != f_id)
	    ;
	return (status ? ERROR : NOERROR);
	}
}
