#include "fsadm.h"
#include <sys/types.h>
#include <sys/dir.h>
#include <fcntl.h>

char pbuf[64];


char *getcwd()
{
  register int fd;
  struct direct dirbuf;

  if ((fd = open(".", O_RDONLY)) == -1) panic("Can't open .");
  read(fd, (char *)&dirbuf, sizeof(dirbuf));
  close(fd);
  *cwd = '\0';
  strcpy(pbuf, "..");
  scanpath(dirbuf.d_ino);
  return(cwd);
}

scanpath(pi)
register ino_t pi;
{
  register int fd;
  struct direct dirbuf;
  register ino_t ti;

  if ((fd = open(pbuf, O_RDONLY)) == -1) panic("Can't open %s", pbuf);
  read(fd, (char *)&dirbuf, sizeof(dirbuf));
  if ((ti = dirbuf.d_ino) == pi) return;
  do {
    read(fd, (char *)&dirbuf, sizeof(dirbuf));
  } while (pi != dirbuf.d_ino);
  close(fd);
  strcat(pbuf, "/..");
  scanpath(ti);
  strcat(strcat(cwd, "/"), dirbuf.d_name);
}
