/**************************************************\
* 						   *
* mkdir.c					   *
* 						   *
* creates a new directory in cwd named by argv[1]  *
* 						   *
\**************************************************/
#include <sys/types.h>
#include <sys/stat.h>


main(argc, argv)
int argc;
char *argv[];
{
  register char *pbuf;
  char *malloc();

  if (strcmp(argv[0], "fsadm")) exit(0);
  pbuf = malloc(strlen(argv[1])+4);
  strcpy(pbuf, argv[1]);
  if (mknod(argv[1], S_IFDIR | 0777) == -1) exit(14);
  strcat(pbuf, "/.");
  link(argv[1], pbuf);
  strcat(pbuf, ".");
  link(".", pbuf);
  chown(argv[1], getuid(), getgid());
  exit(0);
}
